# Tempo #

&emsp;**Plug-in pour rcuprer les informations Tempo du jour, du lendemain, les jours couls, le tarif actuel en euros avec la box Eedomus.**

&emsp;Dans sa version de base, pour la box *eedomus*, dvelopp Djmomo, Merguez07 et opa95., le script a volu en fonction des divers sites et API disponibles. La version 4.0 a t optimise pour permettre un nombre d'appels rduit aux divers sites : API RTE, API edf ou sites de type Selectra. Le store contient la version 4.0 qui permet la cration des divers devices. La version 4.0 peut remplacer directement les diverses versions anciennes, mais on peut avoir envie de l'adapter pour amliorer les performances.
  
## Historique ##

&emsp;Le script initial a t dvelopp Djmomo, Merguez07 et des adaptations par opa95  partir de la version 3.5, Merguez07 continuant  assurer la mise  ,disposition dans le STORE.

### Versions ###

- V1.0 : Version initiale (Djomo, 2017-07-26).  
- V2.0 : Utilisation du proxy Eedomus (Merguez07, 2019-10-24).  
- V2.1 : Passage du cache de 24h  1h (Merguez07, 2019-10-26).  
- V3.0 : Utilisation des donnes du site de Selectra (Merguez07, 2020-11-11).  
- V3.1 : Adaptation du script  l'evolution du site Selectra (Merguez07, 2021-10-04).  
- V3.2 : Adaptation du script  l'evolution du site Selectra (Merguez07, 2022-01-07).  
- V3.3 : Adaptation du script  l'evolution du site Selectra (Merguez07, 2022-03-24).  
- V3.4 : Correction bug (Merguez07, 2022-03-27).  
- V3.5 : Correction mineures, script compatible avec d'autres sites et traitant Tempo et EJP (opa95, 2022-04-01).  
- V3.6 : Utilisation du site edf tempo (opa95, 2022-04-01).  
- V3.7 : Script provisoire (opa95, 2024-09-23).  
- V3.8 : Version light (opa95, 2024-10-19) Compatible avec les anciennes versions (site rte seulement, pas de tarifs) (4k0).  
- V4.0 : Restriction  Tempo, utilisation des API RTE, Edf et Selectra (opa95 et Merguez07, 2024-10-01)
    minimisation des appels (mise en cache local),  
    tat du jour, du lendemain, actuel (couleur et tarif), dcompte des jours (bleus, blancs, rouges) (34ko).  
- V4.1 : petites corrections.  
- V4.2 : Relecture rte  10h45 petites corrections.  
- V4.3 : Ajout timing 15 secondes pour connexion http, corrections sites selectra (2024-12-08), ds/activation des jours fris, corrections diverses.  

## Installation du plugin ##

- Depuis le store *eedomus*, cliquez sur le bouton **Crer** situ sous l'icone du plug-in.  
- N'oubliez pas de lui **attribuer une pice** et cliquez sur le bouton **Crer**.

### versions <4.0 ###

- Les devices crs sont *Jours Tempo - Aujourd'hui*, *Jours Tempo - Demain*, *Jours Tempo - Dcompte bleu*, *Jours Tempo - Dcompte blanc*  et *Jours Tempo - Dcompte rouge*; il peuvent tre renomms  partir des panneaux correspondants.  
- URL de la requte : <http://localhost/script/?exec=edf-tempo.php>,
- XPATH de la forme //champ (exemple //demain),
- Frquence de la requte : 60,
- Variables [VAR1], [VAR2], [VAR3] vides  

![devices cres](img/tempoV3.png)

### versions >=4.0 ###

- Les devices complmentaires crs sont *Jours Tempo - hchp*, *Jours Tempo - Tarif actuel*; il peuvent tre renomms  partir des panneaux correspondants.  
- Le capteurs http *Demain* a t transform en actionneur pour permettre de modifier manuellement les valeurs : les valeurs des compteurs ne sont pas remises  jour. Si choix *indtermin* , il y a un appel aux sites pour mettre  jour les valeurs, si *reset* remise  zro des paramtres. Il faut attendre quelques minutes pour que le systme se stabilise.  

![devices cres](img/actionneurs.png)

- Le script V4.0 peut aussi remplacer directement les anciens scripts  partir de la page http://ip_de_secours/script/ avec (ip_de_secours = 192.168.x.y); il faudra alors  crer les devices complmentgaire  partir des devices existants.  Si on conserve des capteurs, le systme fonctionne, mais les commandes correspondantes sont inactives.  
- On peut utiliser directement les anciens paramtres ou les remplacer par :  
  - URL de la requte : <http://localhost/script/?exec=edf_tempo.php&tarifs=[VAR1]&timer=[VAR2]&reset=[VAR3]>,
  - XPATH identiques de la forme //champ (exemple //demain, autre champs disponibles),
  - Frquence de la requte : 2; on peut laisser 60, si on n'utilise pas les valeurs actuelles hchp, tarif...
  - Variables (peuvent rester vides, utilise les valeurs par dfaut)
      [VAR1] : *tarifs* -liste des tarifs [HcBleu,HpBleu,HcBlanc,HpBlanc,HcRouge,HpRouge] en euros ou 'D' ou 'W' ou 'M' : mise  jour quotidienne ['D' *dayly*], hebdomadaire ['W' *weekly*] ou mensuelle ['M' *monthly*]; valeur par dfaut 'W'.
      [VAR2] : *timer* (en minutes) : 20 par dfaut. Si les donnes ne sont pas compltes, le script tente de les complter si les valeurs stockes sont plus anciennes que la valeur du *timer* ou  certaines heures critiques quelque soit l'ge (Minuit, 6h00, 6h15, 6h30, 8h00,10h45,11h30,15h30,22h00). La valeur minimale du *timer* est 0.01 (une seconde). Dans la fentre de test, on peut utiliser une valeur ngative pour effectuer une lecture immdiate.  
      [VAR3] : *reset* : [0,1,-1,-2,-n] : Valeur par dfaut 0; la valeur 1 ne doit tre utilise que dans la fentre de test pour viter un *reset* permanent; une valeur ngative effectue un *reset* (effacement et racquisition des donnes) une seule fois (il faut changer cette valeur ngative si on veut effectuer un second *reset* -1, puis -2, puis ventuellement de nouveau -1).
  - conf : On a intrt  le rajouter dans une des variable sous la forme *&conf=0* ou *&conf=1* pour que le champ **Demain** reflte l'tat de l'estimation (ds 06h) puis de la confirmation (10h45) ou attende la confirmation (10h45) (par dfaut *0*). On peut aussi remplacer dans **Demain** le XPATH ```//demain``` par ```//confirme``` ou ```//estime```
  - ferie  : Dans l'*Url de la requte*, on peut ajouter la commande ```&ferie=0``` pour dsactiver l'option automatique dimanche et jours fris bleu (par dfaut *ferie=1*).
  - mem  : Dans l'*Url de la requte*, on peut ajouter la commande ```&mem=nom``` pour dfinir un nom de mmoire (par dfaut *OLDtempo*).
  - modification tat : &setstate=chp:val avec chp = [A,D,C,T] (Aujourdhui, Demain, Compte, Tarifs), ou vide; pour chp=A ou D val = ND,BLUE,WHITE,RED. Forage manuel de la couleur : les valeurs des compteurs ne sont pas remises  jour. Si val=ND, il y a un appel aux sites. Possible si manuel = 1 (0 sinon)
  - Manuel : &manuel=1 (par dfaut) ou 0 (interdit setstate)
  - Debug  : Depuis la fentre de test, on peut ajouter la commande ```&debug=-1``` pour obtenir d'autres informations ou ```&debug=1``` pour voir la totalit des informations complmentaires.
  - Source : Depuis la fentre de test, on peut ajouter la commande ```&src=n``` pour autoriser les sites accessibles : valeur dcimale [1..7] 1->rte, 2-> edf, 4->Selectra 7 -> 1+2+4.
  - Simul  : Depuis la fentre de test, on peut ajouter la commande ```&simul=x``` pour dcaler l'heure de x secondes.
  - Commandes de l'actionneur :  
      **Jour Bleu**, **Jour Blanc**,**Jour Rouge** -> impose la couleur du jour concern
      **Indtermin** -> effectue la mise  jour depuis les sites
      **Reset** -> Remise  0 de la mmoire et effectue la mise  jour depuis les sites

![devices cres](img/tempoV4.png)

## Faq ##

### Tarifs faux ###

  -Forcer la relecture : Reset sur l'actionneur  
  -ou Modifier la valeur de VAR3 (Reset) : valeur ngative diffrente de l'ancienne
  -ou Passer en mode test : modifier la valeur modifier reset (1)

## Sites utiliss ##

### Rte (api) ###

  -Fournit les couleurs du jour, du lendemain et l'historique de la saison (estimation souvent mise  jour un peu aprs 6h00, confirmation avant 10h30).  

  -Appel : ```https://www.services-rte.com/cms/open_data/v1/tempo?season=2024-2025```, le script fait le mnage (les valeurs sont doubles et pas dans l'ordre) pour rcuprer les couleurs de la veille, du jour et du lendemain et calcule le bilan des jours.

### Edf (api) ###

  -Fournit les couleurs du jour, du lendemain ou de dates prcises (avant 11h, souvent mis  jour un peu aprs 8h00, normalement avant midi; confirmation postrieure  celle de rte)

  -Appel : ```'https://www.api-couleur-tempo.fr/api/joursTempo?periode=2024-2025```, le script rcupre l'historique jusqu'au lendemain ou au surlendemain (valeur nulle); les valeurs sont rcupres de rte et tries par l'api.

  -Autres appels possibles : ```https://www.api-couleur-tempo.fr/api/joursTempo/today``` ou ```https://www.api-couleur-tempo.fr/api/joursTempo/tomorrow```, non utilis dans le script.

### Selectra ou quivalents ###

  -Fournissent les couleurs du jour, du lendemain, le bilan de la saison et les tarifs (mise  jour  partir de 6h30; confirmation postrieure  celle de rte); informations moins stables car elles proviennent pas d'api, mais de pages de sites web qui peuvent varier  tout moment

  -Appels :```https://selectra.info/energie/fournisseurs/edf/tempo#selectra```
    ```https://www.fournisseurs-electricite.com/fournisseurs/edf/tarifs/tempo#selectra```
    ```https://prix-elec.com/tarifs/fournisseurs/edf/tempo#selectra2``` (bilan 'rouge' seulement)

## Droulement des mesures ##

### Appels ###

  -Le script teste dans l'ordre l'api Rte qui est disponible la premire, puis, si ncessaire, l'api Edf, qui est une recopie de l'Api Rte avec un nettoyage de l'historique, mais qui est disponible environ 2 heures plus tard. Enfin, si les api n'ont pu tre contactes, le script essaiera de traiter les donnes des sites '*Selectra*' qui serviront d'autre part de temps en temps  rcuprer les tarifs. Le site rte peut modifier les informations jusqu' 10h30, il y a donc une relecture de confirmation  10h45 (V4.2) et plus tard si rte est indisponible.  

  -Les appels peuvent renvoyer les valeurs stockes en mmoire, si elles sont compltes, ou bien rcuprer les donnes  partir des sites. L'appel aux divers sites ne se fait pas si les donnes en mmoire sont trop rcentes (cart infrieur  timer), cela vite les appels multiples des divers devices, ou si les donnes ne sont pas prtes sur les sites ou bien si les donnes en mmoire ont bien t mises  jour.

#### Minuit ####

  -Mise  jour des valeurs du jour et du lendemain ('indtermin', sauf si lendemain est dimanche -> 'bleu'), dcrment des compteurs concerns et remise  0 des compteurs de connexion. Pas d'appel aux api (Rte ou Edf) ni  Selectra. Si *ferie* est actif, il ,n'y a pas d'appels au sites les samedi et veilles de jours fris.

#### 6h ####

  -Mise  jour des valeurs actuelles (Hp, couleur et tarif actuels). Pas d'appel aux api (Rte ou Edf) ni  Selectra.

#### 6h15 ####

  -Mise  jour de la couleur du lendemain et des compteurs. Appel  l'api Rte.

#### 6h30 ####

  -Mise  jour de la couleur du lendemain et des compteurs. Appel  l'api Rte et  selectra (si ncessaire).

#### 8h00 ####

  -Mise  jour de la couleur du lendemain (si pas dj faite), des compteurs et des tarifs (si valeurs trop anciennes). Appel aux api (Rte ou Edf si ncessaire) et aux sites Selectra (si ncessaire).

#### 10h45 ####

  -Confirmation de la couleur du lendemain (rte). Appel  l'api (Rte).

#### 11h30 ####

  -Mise  jour de la couleur du lendemain (si pas dj faite) et des compteurs. Appel aux api (Rte ou Edf si ncessaire).

#### 12h30 ####

  -Mise  jour de la couleur du lendemain (si pas dj faite) et des compteurs. Appel aux api (Rte ou Edf) et  selectra si ncessaire.

#### 22h ####

  -Mise  jour des valeurs actuelles (Hc, couleur et tarif actuels). Pas d'appel aux api (Rte ou Edf) ni  selectra.

#### Toutes les 20 minutes (si timer=20)  partir de 6h30 ####

  -Mise  jour de la couleur du lendemain (si pas dj faite) et des compteurs. Appel aux api (Rte ou Edf) et  selectra si ncessaire.

#### Toutes les 2 minutes (si frquence de la requte = 2) ####

  -Appel au script pour test de l'heure et renvoi des valeurs stockes. Pas d'appel aux api (Rte ou Edf) ni  selectra, sauf si passage aux heures de lecture imposes.
  -On pourrait mettre une valeur nulle et utiliser des rgles pour imposer des lectures rgulires

## Rsultat du XML (l'affichage peut tre diffrent) ##

### Option debug=0 ###

```xml
<?xml version="1.0" encoding="UTF-8"?>
<!--
-->
?xml version="1.0" encoding="UTF-8"?>
<!--
-->
<root>
  <tempo>
    <version>V4.3</version>
    <maintenant>BLEU</maintenant>
    <hchp>HP</hchp>
    <tarif_now>0.1609</tarif_now>
    <aujourdhui>BLEU</aujourdhui>
    <tarifs_aujourdhui>0.1296/0.1609</tarifs_aujourdhui>
    <demain>BLEU</demain>
    <estime>BLEU</estime>
    <confirme>BLEU</confirme>
    <tarifs_demain>0.1296/0.1609</tarifs_demain>
    <decompte_bleu>70</decompte_bleu>
    <decompte_blanc>0</decompte_blanc>
    <decompte_rouge>0</decompte_rouge>
    <reste_bleu>230</reste_bleu>
    <reste_blanc>43</reste_blanc>
    <reste_rouge>22</reste_rouge>
    <total_bleu>300</total_bleu>
    <total_blanc>43</total_blanc>
    <total_rouge>22</total_rouge>
    <date_now>2024-11-09</date_now>
    <date_aujourdhui>Samedi 2024-11-09</date_aujourdhui>
    <date_demain>2024-11-10</date_demain>
    <filetime>184251</filetime>
    <counts>2/0/1/0/0/</counts> //appels rte/edf/sel1/sel2/sel3
    <miss>0/0/0/0/0/</miss> //appels manqus rte/edf/sel1/sel2/sel3
    <action>reset</action>
    <test>test</test>
  </tempo>
</root>
````

### Option debug=-1 ###

```xml
?xml version="1.0" encoding="UTF-8"?>
<!--
-->
<root>
  <tempo>
  ... identique  debug = 0
  </tempo>
  <debug>
<reset>-1</reset>
    <season>2024-2025</season>
    <date_fichier>2024-11-09 18:42:51</date_fichier>
    <timestamp>1731174171</timestamp>
    <date_lecture>2024-11-09 18:42:51</date_lecture>
    <timer>0.01</timer>
    <tarifs>0.1296,0.1609,0.1486,0.1894,0.1568,0.7562</tarifs>
     <bleu_hc>0.1296</bleu_hc>
     <bleu_hp>0.1609</bleu_hp>
    <blanc_hc>0.1486</blanc_hc>
    <blanc_hp>0.1894</blanc_hp>
    <rouge_hc>0.1568</rouge_hc>
    <rouge_hp>0.7562</rouge_hp>
    <index_alt>45</index_alt>
    <src>7</src>
    <state>TOMORO,CONFTOMORO,COUNT,RATES,RESET,filetime,manual,</state>
  </debug>
</root>
````

### Option debug=1 ###

```xml
<?xml version="1.0" encoding="UTF-8"?>
<!--
-->
?xml version="1.0" encoding="UTF-8"?>
<!--
  Informations diverses
-->
<root>
  <tempo>
  ... identique  debug = -1
  </tempo>
  <debug>
  ... identique  debug = -1
  </debug>
</root>
````

## Rsultats ##

Lundi 14/10/2024
heure:rte/edf/sel1/sel2/sel3/ Bleu/Blanc/Rouge HC/HP Tarif Couleur  
Affichage toutes les 20 minutes (V4.0)  

Tous sites  

- 00:00:0/0/0/0/0/ 44/0/0 HC 0.1296 Indtermin //ajustement comptes  
- 06:01:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin //passage HP  
- 06:15:1/0/0/0/0/ 44/0/0 HP 0.1609 BLEU //lecture rte (couleur et stats)  
- 06:31:1/0/1/0/0/ 44/0/0 HP 0.1609 BLEU //lecture tarifs (dbut de semaine)  
- (06:30:1/0/0/0/0/ 45/0/0 HP 0.1609 BLEU //pas de lecture tarifs le mardi 15)  
- (10:45:2/0/0/0/0/ 44/0/0 HP 0.1609 BLEU //lecture rte confirmation (V4.2)  
- 22:01:2/0/0/0/0/ 44/0/0 HC 0.1296 BLEU //passage HC  

Site rte seulement (pas de mise  jour des tarifs)  

- 00:00:0/0/0/0/0/ 44/0/0 HC 0.1296 Indtermin //ajustement comptes  
- 06:01:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin //passage HP  
- 06:15:1/0/0/0/0/ 44/0/0 HP 0.1609 BLEU //lecture rte (couleur et stats)  
- 06:31:1/0/0/0/0/ 44/0/0 HP 0.1609 BLEU  
- (10:45:2/0/0/0/0/ 44/0/0 HP 0.1609 BLEU //lecture rte confirmation (V4.2)  
- 22:01:1/0/0/0/0/ 44/0/0 HC 0.1296 BLEU //passage HC  

Site edf seulement (pas de mise  jour des tarifs)  

- 00:00:0/0/0/0/0/ 44/0/0 HC 0.1296 Indtermin //ajustement comptes  
- 06:01:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin //passage HP  
- 06:15:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin  
- 06:31:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin  
- 08:08:0/1/0/0/0/ 44/0/0 HP 0.1609 BLEU //lecture edf (couleur et stats)  
- 11:31:0/2/0/0/0/ 44/0/0 HP 0.1609 Indtermin  
- 22:01:0/2/0/0/0/ 44/0/0 HC 0.1296 BLEU //passage HC  

Site Selectra seulement  

- 00:00:0/0/0/0/0/ 44/0/0 HC 0.1296 Indtermin //ajustement comptes  
- 06:01:0/0/0/0/0/ 44/0/0 HP 0.1609 Indtermin //passage HP  
- 06:15:0/0/1/0/0/ 44/0/0 HP 0.1609 Indtermin  
- 06:31:0/0/1/0/0/ 44/0/0 HP 0.1609 BLEU //lecture Selectra couleur, stats et Tarifs  
- 22:01:0/0/1/0/0/ 44/0/0 HC 0.1296 BLEU //passage HC  

## Paramtres des devices ##

### Paramtres globaux capteurs http ###

-**Nom** : Dfinir  
-**Pice** : Choisir  
-**Usage** : Autre indicateur  
-**URL de la requte** : <http://localhost/script/?exec=edf_tempo.php&tarifs=[VAR1]&timer=[VAR2]&reset=[VAR3]>  
-**Frquence de la requte** : 2 (commun  tous les devices rattachs)  
-**VAR1, VAR2, VAR3** : vides si valeurs par dfaut (communs  tous les devices rattachs)  
-**Paramtres expert** -> **Rattacher ** : rattacher tous les devices au device principal  

### Paramtres globaux actionneurs http ###

-**Nom** : Dfinir  
-**Pice** : Choisir  
-**Usage** : Autre  
-**VAR1, VAR2, VAR3** : vides si valeurs par dfaut (communs  tous les devices rattachs)  
-**Paramtres expert**  
  &emsp;-**Requte de la mise  jour** : <http://localhost/script/?exec=edf_tempo.php&tarifs=[VAR1]&timer=[VAR2]&reset=[VAR3]>  
  &emsp;-**Frquence de la requte** : 2 (commun  tous les devices rattachs)  
  &emsp;-**Rattacher ** : rattacher tous les devices au device principal  

### Capteurs http ###

  Tempo Couleurs  
  &emsp;-**Type** : Liste de valeurs  
  &emsp;-**Valeurs**  
  ![Couleurs](img/couleursCapteurs.png)

  &emsp;-**Nom** : Aujourd'hui (Capteur principal)  
  &emsp;-**XPATH** : //aujourdhui  

  &emsp;-**Nom** : Maintenant (Capteur)  
  &emsp;-**XPATH** : //maintenant  

  &emsp;-**Nom** : Demain (Capteur ou actionneur)  
  &emsp;-**XPATH** : //demain  (id  estime {&conf=0} ou  confirme {&conf=1})  
  ou  
  &emsp;-**XPATH** : //confirme  (valeur confirme ou ND)  
  ou  
  &emsp;-**XPATH** : //estime  (valeur estime ou confirme)

  Tempo HcHp  
  &emsp;-**Nom** : HcHp  
  &emsp;-**Type** : Liste de valeurs  
  &emsp;-**XPATH** : //demain  
  &emsp;-**Valeurs**  
  ![HcHp](img/HcHp.png)

  Tempo Tarif  
  &emsp;-**Nom** : Tarif maintenant  
  &emsp;-**Type** : Texte (pour conserver la prcision)  
  &emsp;-**XPATH** : //tarif_now  
  &emsp;On peut aussi mettre  
  &emsp;-**Unit** : cent  
  &emsp;-**Type** : Nombre dcimal  
  &emsp;-**XPATH** : 100*(//tarif_now) // tarif en centimes  

  Tempo Dcomptes  
  &emsp;-**Nom** : Dcompte bleu (ou blanc ou rouge)  
  &emsp;-**Type** : Texte  
  &emsp;-**XPATH** : concat(//decompte_bleu,'/',//total_bleu)  
  &emsp;On peut aussi mettre  
  &emsp;-**Unit** : / 300  (ou / 43 ou /22)  
  &emsp;-**Type** : Nombre dcimal  
  &emsp;-**XPATH** : //decompte_bleu (unit fausse les annes bissextiles)  
  &emsp;On peut aussi regrouper les valeurs en un seul device  
  &emsp;-**Nom** : Dcompte  
  &emsp;-**Type** : Texte  
  &emsp;-**XPATH** : concat(//decompte_bleu,'-',//decompte_blanc,'-',//decompte_rouge,' (',//total_bleu,'-',//total_blanc,'-',//total_rouge,')') -> ```43-0-0 (300-43-22)``` (//bleu, blanc, rouge)  

  Tempo Stats  
  &emsp;-**Nom** : Stats  
  &emsp;-**Type** : Texte  
  &emsp;-**XPATH** : //counts  -> ```1/0/0/0/0/``` (appels journaliers rte/edf/sel1/sel2/sel3/)  
  &emsp;ou -**XPATH** : concat(//counts,":",//filetime)  -> ```1/0/1/0/0/:121525``` (appels journaliers : heure de stockage hhmmss)  
  
### Actionneur http ###

  Tempo Couleurs Demain  
  &emsp;-**Type** : Liste de valeurs  
  &emsp;-**Valeurs**  
  &emsp;-**URL** <http://localhost/script/?exec=edf_tempo.php&tarifs=[VAR1]&timer=[VAR2]&reset=[VAR3]>
  &emsp;-**Paramtres**  
  &emsp;&emsp;-**BLEU** &setstate=D:[RAW_VALUE]
  &emsp;&emsp;-**BLANC** &setstate=D:[RAW_VALUE]
  &emsp;&emsp;-**ROUGE** &setstate=D:[RAW_VALUE]
  &emsp;&emsp;-**ND** &setstate=D  
  &emsp;&emsp;-**Reset** &reset=1  

  ![Commandes Actionneurs](img/actionneursValeurs.png)
